Titanium.networkProxy = window.TitaniumNetwork;
//Titanium.Net is aliased at the bottom for Titanium.Network

var HTTPClient = function() {
	this.obj; // reference to java TitaniumHttpClient
	this._onreadystatechange;

	this.getReadyState = function() {
		return this.obj.getReadyState();
	};

	this.getResponseText = function() {
		return this.obj.getResponseText();
	};

	this.getStatus = function() {
		return this.obj.getStatus();
	};

	this.getStatusText = function() {
		return this.obj.getStatusText();
	};

	this.abort = function() {
		this.obj.abort();
	};

	this.getAllResponseHeaders = function() {
		return this.obj.getAllResponseHeaders();
	};

	this.getResponseHeader = function(header) {
		return this.obj.getResponseHeader(header);
	};

	this.open = function(method, url) {
		this.obj.open(method, url); // Don't currently support other args
	};

	this.send = function() {
		for(i=0; i < arguments.length; i++) {
			d = arguments[i];
			for(key in d) {
				value = d[key];
				if (typeof value != 'object') {
					this.obj.addPostData(key, String(d[key]));
				} else {
					this.obj.addTitaniumFileAsPostData(key, d[key]);
				}
			}
		}
		this.obj.send(null);
	};

	this.setRequestHeader = function(name,value) {
		this.obj.setRequestHeader(name,value);
	};

	this.setOnReadyStateChange = function(f) {
		_onreadystatechange = f;
		this.obj.setOnReadyStateChangeCallback(registerCallback(this, f));
	};
};

HTTPClient.prototype.__defineGetter__("onreadystatechange", function(){
	return this._onreadystatechange
});
HTTPClient.prototype.__defineSetter__("onreadystatechange", function(f) {
	this.setOnReadyStateChange(f);
});
HTTPClient.prototype.__defineGetter__("readyState", function(){
	return this.getReadyState();
});
HTTPClient.prototype.__defineGetter__("responseText", function(){
	return this.getResponseText();
});
HTTPClient.prototype.__defineGetter__("status", function(){
	return this.getStatus();
});
HTTPClient.prototype.__defineGetter__("statusText", function(){
	return this.getStatusText();
});

Titanium.Network = {
	createTCPSocket : function() {
		//TODO implement Network.createTCPSocket
	},
	createIRCClient : function() {
		//TODO implement Network.IRCClient
	},
	createIPAddress : function() {
		//TODO implement Network.createIPAddress
	},
	createHTTPClient : function() {
		var c = new HTTPClient();
		c.obj = Titanium.networkProxy.createHTTPClient();
		return c;
	},
	getHostByName : function() {
		//TODO implement Network.getHostByName
	},
	getHostByAddress : function() {
		//TODO implement Network.getHostByAddress
	},
	encodeURIComponent : function(x) {
		return window.encodeURIComponent(x);
	},
	decodeURIComponent : function(x) {
		return window.decodeURIComponent(x);
	},
	addEventListener : function(eventName, listener) {
		return Titanium.networkProxy.addEventListener(eventName, registerCallback(this, listener));
	},
	removeEventListener : function(eventName, listenerId) {
		Titanium.networkProxy.removeEventListener(eventName, listenerId);
	},
	addConnectivityListener : function(f) {
		var fn = function(data) {
			f(data.online,data.type);
		};
		return Titanium.networkProxy.addConnectivityListener(registerCallback(this, fn));
	},
	removeConnectivityListener : function(id) {
		return removeEventListener('connectivity', id);
	},

	NETWORK_NONE: 0,
	NETWORK_WIFI: 1,
	NETWORK_MOBILE: 2,
	NETWORK_LAN: 3,
	NETWORK_UNKNOWN: 4
};

Titanium.Network.__defineGetter__("online", function() {
	return Titanium.networkProxy.isOnline();
});

Titanium.Network.__defineGetter__("networkTypeName", function() {
	return Titanium.networkProxy.getNetworkTypeName();
});

Titanium.Network.__defineGetter__("networkType", function() {
	return Titanium.networkProxy.getNetworkType();
});

// alias this to what's in Desktop
Titanium.Net = Titanium.Network;

